function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var colors = {
  red: ['red', 31],
  green: ['green', 32],
  blue: ['blue', 34],
  white: ['white', 37],
  cyan: ['cyan', 36],
  magenta: ['magenta', 35],
  yellow: ['yellow', 33],
  orange: ['orange', 93]
};
/* eslint-disable @typescript-eslint/ban-types */

var _Object$values$reduce = /*#__PURE__*/Object.values(colors).reduce(function (cols, col) {
  var _extends2;

  return _extends({}, cols, (_extends2 = {}, _extends2[col[0]] = function (f) {
    return "\x1B[" + col[1] + "m" + f + "\x1B[0m";
  }, _extends2));
}, {}),
    orange = _Object$values$reduce.orange;

// A type of promise-like that resolves synchronously and supports only one observer
const _Pact = /*#__PURE__*/(function() {
	function _Pact() {}
	_Pact.prototype.then = function(onFulfilled, onRejected) {
		const result = new _Pact();
		const state = this.s;
		if (state) {
			const callback = state & 1 ? onFulfilled : onRejected;
			if (callback) {
				try {
					_settle(result, 1, callback(this.v));
				} catch (e) {
					_settle(result, 2, e);
				}
				return result;
			} else {
				return this;
			}
		}
		this.o = function(_this) {
			try {
				const value = _this.v;
				if (_this.s & 1) {
					_settle(result, 1, onFulfilled ? onFulfilled(value) : value);
				} else if (onRejected) {
					_settle(result, 1, onRejected(value));
				} else {
					_settle(result, 2, value);
				}
			} catch (e) {
				_settle(result, 2, e);
			}
		};
		return result;
	};
	return _Pact;
})();

// Settles a pact synchronously
function _settle(pact, state, value) {
	if (!pact.s) {
		if (value instanceof _Pact) {
			if (value.s) {
				if (state & 1) {
					state = value.s;
				}
				value = value.v;
			} else {
				value.o = _settle.bind(null, pact, state);
				return;
			}
		}
		if (value && value.then) {
			value.then(_settle.bind(null, pact, state), _settle.bind(null, pact, 2));
			return;
		}
		pact.s = state;
		pact.v = value;
		const observer = pact.o;
		if (observer) {
			observer(pact);
		}
	}
}

function _isSettledPact(thenable) {
	return thenable instanceof _Pact && thenable.s & 1;
}

// Asynchronously iterate through an object that has a length property, passing the index as the first argument to the callback (even as the length property changes)
function _forTo(array, body, check) {
	var i = -1, pact, reject;
	function _cycle(result) {
		try {
			while (++i < array.length && (!check || !check())) {
				result = body(i);
				if (result && result.then) {
					if (_isSettledPact(result)) {
						result = result.v;
					} else {
						result.then(_cycle, reject || (reject = _settle.bind(null, pact = new _Pact(), 2)));
						return;
					}
				}
			}
			if (pact) {
				_settle(pact, 1, result);
			} else {
				pact = result;
			}
		} catch (e) {
			_settle(pact || (pact = new _Pact()), 2, e);
		}
	}
	_cycle();
	return pact;
}

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

// Asynchronously iterate through an object's values
// Uses for...of if the runtime supports it, otherwise iterates until length on a copy
function _forOf(target, body, check) {
	if (typeof target[_iteratorSymbol] === "function") {
		var iterator = target[_iteratorSymbol](), step, pact, reject;
		function _cycle(result) {
			try {
				while (!(step = iterator.next()).done && (!check || !check())) {
					result = body(step.value);
					if (result && result.then) {
						if (_isSettledPact(result)) {
							result = result.v;
						} else {
							result.then(_cycle, reject || (reject = _settle.bind(null, pact = new _Pact(), 2)));
							return;
						}
					}
				}
				if (pact) {
					_settle(pact, 1, result);
				} else {
					pact = result;
				}
			} catch (e) {
				_settle(pact || (pact = new _Pact()), 2, e);
			}
		}
		_cycle();
		if (iterator.return) {
			var _fixup = function(value) {
				try {
					if (!step.done) {
						iterator.return();
					}
				} catch(e) {
				}
				return value;
			};
			if (pact && pact.then) {
				return pact.then(_fixup, function(e) {
					throw _fixup(e);
				});
			}
			_fixup();
		}
		return pact;
	}
	// No support for Symbol.iterator
	if (!("length" in target)) {
		throw new TypeError("Object is not iterable");
	}
	// Handle live collections properly
	var values = [];
	for (var i = 0; i < target.length; i++) {
		values.push(target[i]);
	}
	return _forTo(values, function(i) { return body(values[i]); }, check);
}

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

var getResultsFromFnsList = function getResultsFromFnsList(ctx, resolutionType, fns // eslint-disable-line @typescript-eslint/no-explicit-any
) {
  try {
    var results = [];

    var _temp3 = function () {
      if (resolutionType === 'sequential') {
        var _temp4 = _forOf(fns, function (fn) {
          var _results = results,
              _push = _results.push;
          return Promise.resolve(fn(ctx)).then(function (_fn) {
            _push.call(_results, _fn);
          });
        });

        if (_temp4 && _temp4.then) return _temp4.then(function () {});
      } else {
        return Promise.resolve(Promise.all(fns.map(function (fn) {
          return fn(ctx);
        }))).then(function (_Promise$all) {
          results = _Promise$all;
        });
      }
    }();

    return Promise.resolve(_temp3 && _temp3.then ? _temp3.then(function () {
      return results;
    }) : results);
  } catch (e) {
    return Promise.reject(e);
  }
};

var logPropertyIntersection = function logPropertyIntersection(intersection) {
  console.warn("\uD83D\uDFE0 " + orange('Intersection detected') + ": " + JSON.stringify(intersection, null, 2));
};

var shallowEqual = function shallowEqual(object1, object2) {
  if (object1 === void 0) {
    object1 = {};
  }

  if (object2 === void 0) {
    object2 = {};
  }

  if (!object1 || !object2) return;
  var keys1 = Object.keys(object1);
  var keys2 = Object.keys(object2);
  if (!keys1.length || !keys2.length) return;

  for (var _i = 0, _keys = keys1; _i < _keys.length; _i++) {
    var key = _keys[_i];

    if (object1[key] === object2[key]) {
      return object2;
    }
  }

  return;
};

var mergeResults = function mergeResults(results, debug) {
  if (debug === void 0) {
    debug = false;
  }

  var result = results.find(function (result) {
    var _result$redirect;

    return (_result$redirect = result.redirect) !== null && _result$redirect !== void 0 ? _result$redirect : result.notFound;
  });

  if (result === null || result === void 0 ? void 0 : result.redirect) {
    return {
      redirect: result.redirect
    };
  }

  if (result === null || result === void 0 ? void 0 : result.notFound) {
    return {
      notFound: result.notFound
    };
  }

  return results.reduce(function (acc, curr) {
    if (debug && process.env.NODE_ENV !== 'production') {
      var intersection = shallowEqual(acc.props, curr.props);
      if (intersection) logPropertyIntersection(intersection);
    }

    return _extends({}, acc, {
      props: _extends({}, acc.props, curr.props)
    }, curr.revalidate ? {
      revalidate: curr.revalidate
    } : {});
  }, {});
};

var defaultOptions = {
  resolutionType: 'sequential',
  debug: false
};
function mergeProps() // eslint-disable-line @typescript-eslint/no-explicit-any
{
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  var isFirstArgArray = Array.isArray(fns[0]);
  var fnsList = isFirstArgArray ? fns[0] : fns;
  var options = isFirstArgArray ? _extends({}, defaultOptions, fns[1]) : defaultOptions;
  return function (ctx) {
    try {
      return Promise.resolve(getResultsFromFnsList(ctx, options.resolutionType, fnsList)).then(function (results) {
        return mergeResults(results, options.debug);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

export { mergeProps };
//# sourceMappingURL=next-merge-props.esm.js.map
